#!/usr/bin/perl
#
# $Id: checkpoint.pl,v 1.1 2003/01/17 19:13:18 mpeppler Exp $

use strict;

use Sybase::Simple;

my %tables = 
    ( VendorInfo => [qw(vendorInfoId lastModifiedDate)],
      VendorXML => [qw(vendorXMLID dateLastModified)],
      Products => [qw(productId lastModifiedDate)],
      product_detail => [qw(productId lastModifiedDate)],
      Blurbs => [qw(blurbId lastModifiedDate)],
      Payments => [qw(paymentId dateLastModified)],
      Payment_detail => [qw(detailId date)],
      Payment_details => [qw(detailId date)],
      PaymentStateHistory => [qw(paymentStateHistoryId dateInserted)],
      VendorCalcs => [qw(vendorCalcID dateLastModified)],
      Notes => ['noteId'],    # noteId, noteSequence.
      DataType => [qw(dataTypeID lastUpdated)],
      ShortData => [qw(dataID lastUpdated)],
      TTVendor => [qw(vendorId)],
      TTVendorGroup => [qw(vendorGroupId)],
      TTVendor2TTVendorGroup => [qw(vendor2vendorGroupId)],
      TTVendor2rbacUser => [qw(rbacUser2VendorId)],
#      rbacDSC => [qw(rbacDSCId dateCreated)],
      rbacErrorMessage => [qw(errorCode)],
      rbacFunctionHistory => [qw(rbacFunctionHistoryId dateCreated)],
      rbacFunction => [qw(rbacFunctionId dateCreated)],
      rbacLoginHistory => [qw(rbacLoginHistoryId dateCreated)],
      rbacRole2rbacFunction => [qw(rbacRole2rbacFunctionId)],
      rbacRole => [qw(rbacRoleId dateCreated)],
      rbacSessionTrack => [qw(rbacSessionTrackId timeStart)],
#      rbacSSC => [qw(rbacSSCId dateCreated)],
      rbacUser2rbacRole => [qw(rbacUser2rbacRoleId)],
#      rbacUser_save.sql
      rbacUser => [qw(rbacUserId dateStart dateStop dateCreated)],
      WebActionEventData => [qw(webActionEventDataId dateCreated)],
      WebActionEventHit => [qw(webActionEventHitId dateCreated)],
      WebActionEvent => [qw(webActionEventId dateLastModified)],
      WebActionPartName => [qw(webActionPartNameId dateCreated)],
      WebActionStatusAction => [qw(webActionStatusActionId dateLastModified)],
      WebActionType => [qw(webActionTypeId dateCreated)],
      blurbs_products => [qw(id)]
);

system("bcp payment_db..eo_sequence_table out eo_sequence_table.bcp -Usa -Psecret -SZOD -c");
system("bcp payment_db..eoSequenceTable out eoSequenceTable.bcp -Usa -Psecret -SZOD -c");

my $dbh = new Sybase::Simple 'sa', 'secret', 'ZOD';
$dbh->ExecSql("use payment_db");
foreach my $t (sort keys %tables) {
    my $date_cols = $dbh->ArrayOfScalar("
select c.name
  from syscolumns c, systypes t
 where c.id = object_id('$t')
   and c.usertype = t.usertype
   and t.name = 'datetime'");

    print "$t ";
    my %cols;
    foreach my $c (@{$tables{$t}}, @$date_cols) {
	next if($cols{$c});
	my $sql = "select max($c) from $t";
	if(grep($c eq $_, @$date_cols)) {
	    $sql .= " where $c <= getdate()";
	}
	my $data = $dbh->Scalar($sql);
	print "%% $c = $data";
	$cols{$c} = 1;
    }
    print "\n";
}



